#import "ExtrasController.h"

@implementation ExtrasController

- (void)awakeFromNib
{
	NSUserDefaults	*defs=[NSUserDefaults standardUserDefaults];
	
	if([defs objectForKey:kTeXFoG_updates_pref])
		automaticUpdate=[[defs objectForKey:kTeXFoG_updates_pref] boolValue];
	else
		automaticUpdate=kDefaultUpdate;
	
	if(automaticUpdate)
		[updatesMenuItem setState:NSOnState];
	else
		[updatesMenuItem setState:NSOffState];
	
	[self registerForUpdates];
}

- (IBAction)toggleUpdates:(id)sender
{
	NSUserDefaults	*defs=[NSUserDefaults standardUserDefaults];
	
	automaticUpdate=!automaticUpdate;
	[defs setObject:[NSNumber numberWithBool:automaticUpdate] forKey:kTeXFoG_updates_pref];
	[defs synchronize];
	if(automaticUpdate)
	{
		[updatesMenuItem setState:NSOnState];
		[self registerForUpdates];
	}
	else
	{
		[self stopUpdates];
		[updatesMenuItem setState:NSOffState];
	}
}

- (IBAction)visitHomepage:(id)sender
{
	NSMutableString		*comando;
	NSAppleScript		*as;
	
	comando=[NSMutableString stringWithString:@"open location \""];
	[comando appendString:kTeXFoGhomepage];
	[comando appendString:@"\""];
	as=[[NSAppleScript alloc] initWithSource:comando];
	[as executeAndReturnError:nil];
	[as release];
}

- (IBAction)showAbout:(id)sender
{
	[aboutWindow makeKeyAndOrderFront:sender];
}

- (void)registerForUpdates
{
	if(automaticUpdate)
	{
		[self checkForAppUpdates:nil];
		updatesTimer=[NSTimer scheduledTimerWithTimeInterval:kAppUpdateTimerInterval
													  target:self
													selector:@selector(checkForAppUpdates:)
													userInfo:nil
													 repeats:YES];
	}
}

- (void)stopUpdates
{
	[updatesTimer invalidate];
	updatesTimer=nil;
}

- (void)checkForAppUpdates:(NSTimer *)t
{
	NSDictionary		*d;
	
	d=[NSDictionary dictionaryWithContentsOfURL:[NSURL URLWithString:kAppVersionDictionary]];
	if([[d objectForKey:kTeXFoGDictKey] intValue] > kTeXFoGDictVersion)
	{
		[[NSApplication sharedApplication] activateIgnoringOtherApps:YES];
		[newVersionWindow makeKeyAndOrderFront:self];
	}
}

- (IBAction)visitUpdates:(id)sender
{
	[self visitHomepage:self];
	[newVersionWindow orderOut:nil];
}

- (IBAction)dismissUpdates:(id)sender
{
	[newVersionWindow orderOut:nil];
}

@end
